﻿@using System.Security.Claims
@model IEnumerable<ReleaseNote>
@{
    ViewData["Title"] = "Release Notes";
    var role = User.FindFirst(ClaimTypes.Role)?.Value;
    var area = role == Roles.FirmPrincipal ? "firm-principal" : role == Roles.FirmAdmin ? "firm-admin" : "adviser";
}
<div class="container">
    <div class="card">
        <div class="card-body">
            <div class="d-flex justify-content-between">
                <div class="flex-grow-1">
                    <h3 class="card-label text-primary">
                        Release Notes
                    </h3>
                </div>
                @if (role == Roles.SuperAdmin)
                {
                    <div class="align-self-center">
                        <button class="btn btn-primary btn-sm font-weight-bold font-size-h6 mb-5 btn-add-note"><i class="fas fa-plus"></i>New Note</button>
                    </div>
                }
                else
                {
                    <div class="align-self-center">
                        <a onclick="goBackAdviser('@area')" class="btn btn-sm btn-icon btn-outline-primary btn-hover-light-primary btn-circle" data-toggle="tooltip" title="Go Back">
                            <i class="fas fa-arrow-left"></i>
                        </a>
                    </div>
                }
            </div>
            <div class="accordion accordion-light accordion-light-borderless accordion-svg-toggle" id="accordionReleaseNote">
                @foreach (var item in Model)
                {
                    <div class="card" id="note-@item.Guid">
                        <div class="card-header">
                            <div class="card-title collapsed p-0" data-toggle="collapse" data-target="#collapse@(item.Id)">
                                <span class="svg-icon svg-icon-primary">
                                    <svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="24px" height="24px" viewBox="0 0 24 24" version="1.1">
                                        <g stroke="none" stroke-width="1" fill="none" fill-rule="evenodd">
                                            <polygon points="0 0 24 0 24 24 0 24"></polygon>
                                            <path d="M12.2928955,6.70710318 C11.9023712,6.31657888 11.9023712,5.68341391 12.2928955,5.29288961 C12.6834198,4.90236532 13.3165848,4.90236532 13.7071091,5.29288961 L19.7071091,11.2928896 C20.085688,11.6714686 20.0989336,12.281055 19.7371564,12.675721 L14.2371564,18.675721 C13.863964,19.08284 13.2313966,19.1103429 12.8242777,18.7371505 C12.4171587,18.3639581 12.3896557,17.7313908 12.7628481,17.3242718 L17.6158645,12.0300721 L12.2928955,6.70710318 Z" fill="#000000" fill-rule="nonzero"></path>
                                            <path d="M3.70710678,15.7071068 C3.31658249,16.0976311 2.68341751,16.0976311 2.29289322,15.7071068 C1.90236893,15.3165825 1.90236893,14.6834175 2.29289322,14.2928932 L8.29289322,8.29289322 C8.67147216,7.91431428 9.28105859,7.90106866 9.67572463,8.26284586 L15.6757246,13.7628459 C16.0828436,14.1360383 16.1103465,14.7686056 15.7371541,15.1757246 C15.3639617,15.5828436 14.7313944,15.6103465 14.3242754,15.2371541 L9.03007575,10.3841378 L3.70710678,15.7071068 Z" fill="#000000" fill-rule="nonzero" opacity="0.3" transform="translate(9.000003, 11.999999) rotate(-270.000000) translate(-9.000003, -11.999999) "></path>
                                        </g>
                                    </svg>
                                </span>
                                <div class="card-label pl-4">@item.ReleaseVersion - @item.ReleaseDateFormated</div>
                                @if (role == Roles.SuperAdmin)
                                {
                                    <button class="btn btn-sm btn-add-note" data-toggle="tooltip" data-original-title="Edit" data-guid="@item.Guid">
                                        <img src="/images/edit-icon.png" height="25">
                                    </button>
                                    <button class="btn btn-sm btn-icon btn-note-delete" data-toggle="tooltip" data-original-title="Delete" data-guid="@item.Guid">
                                        <img src="/images/delete-icon.png" height="25">
                                    </button>
                                }
                            </div>
                        </div>
                        <div id="collapse@(item.Id)" class="collapse" data-parent="#accordionReleaseNote">
                            <div class="card-body pl-12">
                                @Html.Raw(item.Note)
                            </div>
                        </div>
                    </div>
                }
            </div>
        </div>
    </div>
</div>
<div class="modal" id="ReleaseNoteModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true"></div>
<style>
    .ck.ck-editor__main > .ck-editor__editable.input-validation-error {
        border: 1px solid #f64e60;
    }
</style>
@section scripts{
    <script src="~/lib/ckeditor-classic.bundle.js"></script>
    <script>
        var myEditor;
        var validateCKEditor = function(myEditor) {
            var el = $("#Note-error").closest(".field-validation-error");
            el.addClass("d-none");
            var el2 = $(".ck.ck-editor__main>.ck-editor__editable");
            el2.removeClass("input-validation-error");
            var messageLength = myEditor.getData().replace(/<[^>]*>/gi, '').length;
            if (!messageLength) {
                el.removeClass("d-none");
                el2.addClass("input-validation-error");
                return false;
            }
            else
                return true;
        }
        $(document).on("click", ".btn-add-note,.btn-edit-note", function(e) {
            e.stopPropagation();
            KTApp.blockPage({ overlayColor: '#000000', state: 'primary', message: 'Please wait...' });
            var guid = $(this).attr("data-guid");
            loadPartialView(`admin/superadmin/addreleasenote?guid=${guid}`, "ReleaseNoteModal", null, function() {
                ClassicEditor.create(document.querySelector('#Note'))
                    .then(editor => {
                        myEditor = editor;
                        myEditor.model.document.on('change', () => {
                            validateCKEditor(myEditor);
                        });
                        $("#Note").removeClass("d-none");
                    });
                $("#AddNote_form").submit(function(e) {
                   var validate = validateCKEditor(myEditor);
                    if (!validate) {
                        e.preventDefault();
                        return false;
                    }                        
                });
                var validateLinks = function() {
                    var validated = true;
                    $(".ck-content a").each(function() {
                        var url = $(this).attr("href");
                        if (!isValidURL(url))
                            validated = false;
                    });
                    return validated;
                }
            });
            setTimeout(function() { KTApp.unblockPage(); }, 1000);
            $("#ReleaseNoteModal").modal({ backdrop: 'static' });
        });
        $(document).on("click", ".btn-note-delete", function(e) {
            e.stopPropagation();
            var cur = this;
            var swalOptions = confimationSwalOptions;
            Swal.fire(swalOptions).then(function(result) {
                if (result.value) {
                    var guid = $(cur).attr("data-guid");
                    deleteRecord(`admin/superadmin/deletereleasenote?guid=${guid}`, function(response) {
                        if (response.success) {
                            KTApp.blockPage({ overlayColor: '#000000', state: 'primary', message: 'Please wait...' });
                            setTimeout(function() { KTApp.unblockPage(); }, 1000);
                            $(cur).closest(".card").remove();
                        }
                        else
                            Swal.fire("Cancelled", response.message, "error");
                    });
                }
            });
        });
        var onFormCompleteReleaseNote = function(response) {
            var id = $(this).find(":submit").attr('id');
            id = id == undefined ? $(frm).find(":submit").attr('id') : id;
            var btn = KTUtil.getById(id);
            var frm_id = $(this).attr('id');
            frm_id = frm_id == undefined ? $(frm).attr('id') : frm_id;
            var responseObj = JSON.parse(response.responseText);
            var releaseNote = responseObj.data.releaseNote;
            if (responseObj) {
                if (responseObj.success) {
                    var modalId = $('.modal:visible').attr("id");
                    $(`#${modalId}`).modal('hide');
                    var div = $(`#note-${releaseNote.guid}`)
                    if (div.length > 0)
                        $(`#note-${releaseNote.guid}`).html($("#release-note-template").tmpl(responseObj.data));
                    else {
                        $("#accordionReleaseNote").prepend($("#release-note-template").tmpl(responseObj.data));
                    }
                    $(`#collapse${releaseNote.id} .card-body`).html(releaseNote.note);
                    toastr.clear();
                    toastr.options = toastrOptions;
                    toastr.success(responseObj.message);
                }
                else
                    _showFormMessage(`${frm_id}`, "danger", responseObj.message, "fas fa-exclamation-triangle");
            }
            else
                _showFormMessage(`${frm_id}`, "danger", "Error Occur", "fas fa-exclamation-triangle")
            KTUtil.btnRelease(btn);
        };
    </script>
}